/*
 * 商学院创客学堂
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SchoolMakerStudyController : BaseController
    {
        public SchoolMakerStudyController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商学院创客学堂列表

        /// <summary>
        /// 根据条件查询商学院创客学堂列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SchoolMakerStudy data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商学院创客学堂列表

        /// <summary>
        /// 商学院创客学堂列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SchoolMakerStudy data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Title", "1"); //标题
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            if (!string.IsNullOrEmpty(data.SeoKeyword))
            {
                condition += " and SeoKeyword like '" + data.SeoKeyword + "%'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolMakerStudy", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }
            return Json(obj);
        }

        #endregion

        #region 增加商学院创客学堂

        /// <summary>
        /// 增加或修改商学院创客学堂信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string PColId, string CurColId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.CurColId = CurColId;
            if (string.IsNullOrEmpty(PColId))
            {
                PColId = "001";
            }
            ViewBag.PColId = PColId;

            return View();
        }

        #endregion

        #region 增加商学院创客学堂

        /// <summary>
        /// 增加或修改商学院创客学堂信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SchoolMakerStudy data, string PColId = "", string CurColId = "")
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Title", data.Title); //标题
            Fields.Add("Detail", data.Detail); //介绍
            Fields.Add("ListPic", data.ListPic); //列表图片
            Fields.Add("Contents", data.Contents); //内容
            Fields.Add("QueryCount", data.QueryCount); //学习人数
            Fields.Add("Url", data.Url); //外链

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("SchoolMakerStudy", Fields, 0);
            AddSysLog(data.Id.ToString(), "SchoolMakerStudy", "add");
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 修改商学院创客学堂

        /// <summary>
        /// 增加或修改商学院创客学堂信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string ColId, string PColId, string CurColId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SchoolMakerStudy editData = db.SchoolMakerStudy.FirstOrDefault(m => m.Id == Id) ?? new SchoolMakerStudy();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商学院创客学堂

        /// <summary>
        /// 增加或修改商学院创客学堂信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SchoolMakerStudy data, string PColId = "", string CurColId = "")
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Title", data.Title); //标题
            Fields.Add("Detail", data.Detail); //介绍
            Fields.Add("SeoTitle", data.SeoTitle); //主讲人
            Fields.Add("QueryCount", data.QueryCount); //观看人数
            Fields.Add("ListPic", data.ListPic); //列表图片
            Fields.Add("Contents", data.Contents); //内容
            Fields.Add("Url", data.Url); //外链

            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMakerStudy", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SchoolMakerStudy", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商学院创客学堂信息

        /// <summary>
        /// 删除商学院创客学堂信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMakerStudy", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMakerStudy", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMakerStudy", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMakerStudy", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMakerStudy", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolMakerStudy", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("SchoolMakerStudy", Sort, Id);

            AddSysLog(Id.ToString(), "SchoolMakerStudy", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            var error = "";
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];
                string MakerCode = dr[0].ToString(); // 创客编号
                string Auths = dr[1].ToString(); // 权限
                string[] Auth = Auths.Split(',');
                var fAuth = "";
                var userForMakerCode = db.UserForMakerCode.FirstOrDefault(m => m.MakerCode == MakerCode) ?? new UserForMakerCode();
                var userInfo = db.Users.FirstOrDefault(m => m.Id == userForMakerCode.UserId) ?? new Users();
                var time = 0;
                if (userInfo.Id == 0)
                {
                    error += "创客" + MakerCode + "不存在" + '\n';
                }
                foreach (var item in Auth)
                {
                    var col = bsdb.Col.FirstOrDefault(m => m.ColId == item) ?? new BsModels.Col();
                    if (col.Id == 0)
                    {
                        error += "权限编号" + item + "不存在" + '\n';
                    }
                    else
                    {
                        time += 1;
                        if (time == 1)
                        {
                            fAuth += "," + item + ",";
                        }
                        else
                        {
                            fAuth += item + ",";
                        }
                    }
                }
                if (!string.IsNullOrEmpty(error))
                {
                    return "Warning|" + error;
                }
                var check = db.UserCardRecord.Any(m => m.Id == userInfo.Id);
                if (check)
                {
                    var auth = db.UserCardRecord.FirstOrDefault(m => m.Id == userInfo.Id) ?? new UserCardRecord();
                    foreach (var item in Auth)
                    {

                        if (!auth.SeoDescription.Contains("," + item + ","))
                        {
                            auth.SeoDescription += item + ",";
                        }
                    }
                    auth.UpdateDate = DateTime.Now;
                    auth.UpdateMan = SysUserName + "-" + SysRealName;
                    db.SaveChanges();
                }
                else
                {
                    var query = db.UserCardRecord.Add(new UserCardRecord()
                    {
                        Id = userInfo.Id,
                        CreateDate = DateTime.Now, //创建时间
                        CreateMan = SysUserName + "-" + SysRealName,
                        SeoDescription = fAuth,
                    }).Entity;
                    db.SaveChanges();
                }
            }
            db.SaveChanges();
            AddSysLog("0", "SchoolMakerStudy", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SchoolMakerStudy data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "1"); //标题
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolMakerStudy", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SchoolMakerStudy", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
